******************************************************************
**								**
**		.xvd easy Frame Viewer 2	ver0.81		**
**								**
**						by ӂȂۂ	**
**								**
**					since May 20 1997	**
******************************************************************

	.include	DOSCALL.MAC
	.include	IOCSCALL.MAC
	.include	CONST.H


	.cpu	68000

	.offset	0

MAGIC_HEADER::		.ds.b	4
DATA_AUTHOR::		.ds.b	32
SUB_TITLE::		.ds.b	32
TITLE::			.ds.b	64
END_MARKER::		.ds.b	4
FORMAT_REVISION::	.ds.b	4
DATA_OFFSET::		.ds.b	4
HEADER_OFFSET::		.ds.b	4
FRAME_NUMBER::		.ds.b	4
X_LENGTH::		.ds.b	4
Y_LENGTH::		.ds.b	4
ASPECT_RATIO::		.ds.b	4
IMAGE_TYPE::		.ds.b	4
BASE_TIME_UNIT::	.ds.b	4
FRAME_RATE::		.ds.b	4
PCM_TYPE::		.ds.b	4
PCM_CHANNEL::		.ds.b	4
PCM_FREQENCY::		.ds.b	4
PCM_BLOCK_SIZE::	.ds.b	4

XNumber::		.ds.w	1
YNumber::		.ds.w	1
JumpFrameNumber::	.ds.w	1
SVDFV3ModeFlag::	.ds.w	1
ViewModeFlag::		.ds.w	1
StartNumber::		.ds.w	1
EndNumber::		.ds.w	1
OneFrameFlag::		.ds.w	1
PosterFlag::		.ds.w	1
FileHundle::		.ds.w	1
Xloop::			.ds.w	1
Yloop::			.ds.w	1
DisplayNumber::		.ds.w	1
CULC_X_LENGTH::		.ds.w	1
YAT_YSIZE::		.ds.w	1
ViewSeekNumber::	.ds.w	1
FastDrawFlag::		.ds.w	1
CrtmodeFlag::		.ds.w	1
CrtmodeBuff::		.ds.w	1
CurrentNumber::		.ds.w	1
Yhight::		.ds.w	1
CtrlFlag::		.ds.w	1
TabFlag::		.ds.w	1

CULC_Y_LENGTH::		.ds.l	1
pImageSizeTable::	.ds.l	1
pVramTable::		.ds.l	1
pImage::		.ds.l	1
ImageSize::		.ds.l	1
DrawRoutine::		.ds.l	1
SeekSize::		.ds.l	1
PackedTableSize::	.ds.l	1
pVdpDecodeBuff0::	.ds.l	1
pVdpDecodeBuff1::	.ds.l	1

pImageData::		.ds.l	1
pTempBuff::		.ds.l	1
VRAMAddress::		.ds.l	1

TextPaletBuff::		.ds.w	16
StrBuf::		.ds.b	6
FileName::		.ds.b	256
WORK_SIZE::


	.text
	.even


	lea.l	MYSP(pc),sp			*X^bN|Cgw̃AhX
	movea.l	sp,a1

	lea.l	$c4(a0),a5			*filename

	lea.l	16(a0),a0
	suba.l	a0,a1
	move.l	a1,-(sp)
	move.l	a0,-(sp)
	DOS	_SETBLOCK			*
	addq.l  #8,sp

******************************************************************

**			const figure set			**
******************************************************************

	lea.l	WORK(pc),a6

	pea.l	TitleMes(pc)
	DOS	_PRINT
	addq.l	#4,sp


	lea.l	WORK(pc),a0
	move.w	#WORK_SIZE,d0
	subq.w	#1,d0
@@:
	clr.b	(a0)+
	dbra	d0,@B

	addq.l	#5,a5
	cmpi.b	#'3',(a5)
	bne	@F

	move.w	#1,SVDFV3ModeFlag(a6)
	move.w	#1,PosterFlag(a6)
@@:
******************************************************************
**			option check				**
******************************************************************

SwitchCheck:
	tst.b	(a2)+
	bne	@f
	pea.l	USAGE(pc)
	DOS	_PRINT
	addq.l	#4,a7
	DOS	_EXIT
@@:
	move.b	(a2)+,d0
	cmpi.b	#' ',d0
	beq	@b
	cmpi.b	#'-',d0
	bne	GetFileName

	bsr	SetOption
	beq	NextCommand

	pea.l	NoOptionMes(pc)
	DOS	_PRINT
	addq.l	#4,a7
	DOS	_EXIT

NextCommand:
	tst.b	(a2)
	bne	@b
	pea.l	NoFileMes(pc)
	DOS	_PRINT
	addq.l	#4,a7
	DOS	_EXIT

GetFileName:
	lea.l	FileName(a6),a1
	move.b	d0,(a1)+
@@:
	move.b	(a2)+,d0
	beq	@f
	cmpi.b	#SPACE,d0
	beq	@f
	move.b	d0,(a1)+
	bra	@b
@@:
	clr.b	(a1)

******************************************************************
**			Header Read				**
******************************************************************

	move.w	#2,-(sp)			* READ
	pea.l	FileName(a6)
	DOS	_OPEN				*
	addq.l	#6,sp

		bmi	OpenError
		move.w	d0,FileHundle(a6)

	move.l	#192,-(sp)			*Poster_Data܂ł̃wb_ől
	pea.l	MAGIC_HEADER(a6)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.l	FRAME_NUMBER(a6),d0
	add.l	d0,d0
	add.l	d0,d0				*x4
	move.l	d0,-(sp)
	DOS	_MALLOC
	addq.l	#4,sp

		bmi	MallocError

	move.l	d0,pImageSizeTable(a6)

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	HEADER_OFFSET(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	FRAME_NUMBER(a6),d0
	add.l	d0,d0
	add.l	d0,d0

	move.l	d0,-(sp)
	move.l	pImageSizeTable(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

******************************************************************
**		Data Check & Culculation			**
******************************************************************

	cmpi.l	#'XVDF',MAGIC_HEADER(a6)
	bne	NotXvdData

	moveq.l	#0,d0
	move.w	JumpFrameNumber(a6),d0
	cmp.l	FRAME_NUMBER(a6),d0
	bhi	FrameNumberError

	moveq.l	#0,d0
	move.w	EndNumber(a6),d0
	cmp.l	FRAME_NUMBER(a6),d0
	bhi	FrameNumberError

	cmpi.w	#$0002,FORMAT_REVISION(a6)
	bne	NotRev2

	move.w	XNumber(a6),d0
	add.w	X_LENGTH+2(a6),d0
	cmpi.w	#512,d0
	bhi	OverXNumber

	move.w	YNumber(a6),d0
	add.w	Y_LENGTH+2(a6),d0
	cmpi.w	#512,d0
	bhi	OverYNumber

	move.w	IMAGE_TYPE+2(a6),d0
	cmpi.w	#3,d0
	bhi	ImageTypeError
	tst.w	PosterFlag(a6)
	bne	@F
	moveq.l	#0,d0				* Poster
@@:
	add.w	d0,d0
	add.w	d0,d0
	move.l	ImageTypeTable(pc,d0.w),DrawRoutine(a6)
	bra	Calculation

ImageTypeTable::
	.dc.l	ImageType0
	.dc.l	ImageType1
	.dc.l	ImageType1
	.dc.l	ImageType3

**************************
**	Calculation	**
**************************

Calculation::
	move.l	X_LENGTH(a6),d0
	move.l	Y_LENGTH(a6),d1
	mulu.w	d1,d0
	add.l	d0,d0
	move.l	d0,ImageSize(a6)

	move.w	X_LENGTH+2(a6),d0
	move.w	Y_LENGTH+2(a6),d1
	mulu.w	d0,d1
	lsr.l	#1,d1
	addq.l	#1,d1
	andi.l	#$ffff_fffe,d1			* d1 = packed table size
	move.l	d1,PackedTableSize(a6)		*X*Y/2 +1

	move.w	X_LENGTH+2(a6),d0
	lsr.w	#1,d0				*d2/2
	subq.w	#1,d0
	move.w	d0,CULC_X_LENGTH(a6)		*X/2-1

	move.l	X_LENGTH(a6),d0
	move.l	#512,d1
	sub.l	d0,d1
	add.l	d1,d1
	move.l	d1,CULC_Y_LENGTH(a6)

	move.w	Y_LENGTH+2(a6),d0
	subq.w	#1,d0
	move.w	d0,YAT_YSIZE(a6)		*Y-1

	move.l	Y_LENGTH(a6),d0
	add.l	d0,d0
	add.l	d0,d0
	lsl.l	#8,d0
	move.l	d0,d1
	add.l	d0,d0

	move.l	d0,-(sp)		*Y x1024 x2
	DOS	_MALLOC
	addq.l	#4,sp

		bmi	MallocError

	move.l	d0,pVdpDecodeBuff0(a6)		*d0:KEEP
	add.l	d0,d1
	move.l	d1,pVdpDecodeBuff1(a6)		*d0:KEEP

******************************************************************
**			configure				**
******************************************************************

	tst.w	SVDFV3ModeFlag(a6)
	bne	SVDFV3Mode

	tst.w	PosterFlag(a6)
	beq	PosterDisplay

	tst.w	XNumber(a6)
	bne	x1Display
	tst.w	OneFrameFlag(a6)
	beq	HowManyImage

PosterDisplay::
	move.l	#192,SeekSize(a6)
	move.w	#1,DisplayNumber(a6)
	lea.l	ImageSize(a6),a0
	move.l	a0,pImageSizeTable(a6)
	bra	makeVramTable

HowManyImage::
	move.l	X_LENGTH(a6),d1
	move.l	#512,d0
	divu.w	d1,d0
	move.w	d0,d2
	subq.w	#1,d0
	move.w	d0,Xloop(a6)			* X

	move.l	Y_LENGTH(a6),d1
	move.l	#512,d0
	divu.w	d1,d0
	move.w	d0,d1
	subq.w	#1,d0
	move.w	d0,Yloop(a6)			* X

	mulu.w	d2,d1
	move.w	d1,DisplayNumber(a6)		* \

	move.w	FRAME_NUMBER+2(a6),d0
	sub.w	JumpFrameNumber(a6),d0
	cmp.w	d1,d0
	bhi	calcSeekSize
	move.w	d0,DisplayNumber(a6)
	bra	calcSeekSize

x1Display::
	move.w	#1,DisplayNumber(a6)

calcSeekSize::
	move.l	pImageSizeTable(a6),a0
	move.l	DATA_OFFSET(a6),d0
	move.w	JumpFrameNumber(a6),d1
	tst.w	ViewModeFlag(a6)
	beq	@F
	move.w	StartNumber(a6),d1
@@:
	tst.w	d1
	beq	1F
	subq.w	#1,d1

@@:
		add.l	(a0)+,d0
		add.l	PCM_BLOCK_SIZE(a6),d0
		dbra	d1,@B
1:
	move.l	d0,SeekSize(a6)
	move.l	a0,pImageSizeTable(a6)

******************************************************************
**			VRAM Table				**
******************************************************************

makeVramTable::
	moveq.l	#0,d0
	move.w	DisplayNumber(a6),d0		* \
	add.l	d0,d0
	add.l	d0,d0

	move.l	d0,-(sp)
	DOS	_MALLOC
	addq.l	#4,sp

		bmi	MallocError

	move.l	d0,pVramTable(a6)
	move.l	d0,a0

**************************
**	ʒu	**
**************************

	move.l	#$00c0_0000,a1

	moveq.l	#0,d0
	move.w	XNumber(a6),d0
	add.w	d0,d0
	add.l	d0,a1
	moveq.l	#0,d0
	move.w	YNumber(a6),d0
	add.l	d0,d0
	add.l	d0,d0
	lsl.l	#8,d0
	adda.l	d0,a1

**************************
**			**
**************************

	move.w	Xloop(a6),d6
	move.w	Yloop(a6),d7

	move.l	X_LENGTH(a6),d2
	add.l	d2,d2				* 1dot = 1 word
	move.l	Y_LENGTH(a6),d3
	add.l	d3,d3
	add.l	d3,d3
	lsl.l	#8,d3				*x1024

2:
	move.l	a1,a2
	move.l	d6,d5
1:
		move.l	a2,(a0)+		*pVramTable
		adda.l	d2,a2
		dbra	d5,1B

	adda.l	d3,a1
	dbra	d7,2B

******************************************************************
**			View Mode				**
******************************************************************

	tst.w	ViewModeFlag(a6)
	beq	notViewMode

	move.w	StartNumber(a6),d0
	move.w	EndNumber(a6),d1
	bne	@F
	move.w	FRAME_NUMBER+2(a6),d1
@@:
	cmp.w	d1,d0
	bcc	ViewNumberError

	sub.w	d0,d1
	move.w	DisplayNumber(a6),d0
	divu.w	d0,d1				* (e - s) / d
	tst.w	d1
	bne	@F
	move.w	#1,DisplayNumber(a6)		* \
@@:
	move.w	d1,ViewSeekNumber(a6)
notViewMode::

******************************************************************
**								**
******************************************************************

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	SeekSize(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	ImageSize(a6),-(sp)
	DOS	_MALLOC
	addq.l	#4,sp

		bmi	MallocError

	move.l	d0,pImage(a6)

**************************
**	CRTC		**
**************************

X68K_ORIGINAL::
	move.w	#$000C,d1
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON

	tst.l	ASPECT_RATIO(a6)
	beq	@F

SQUARE::
	move.w	#$0110,d1
	IOCS	_CRTMOD

		suba.l	a1,a1
		IOCS	_B_SUPER

	move.w	#$0316,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600

		move.l	d0,a1
		IOCS	_B_SUPER
@@:

******************************************************************
**			main loop				**
******************************************************************

	move.l	pVramTable(a6),a4
	move.l	pImageSizeTable(a6),a5
	move.w	DisplayNumber(a6),d7		* \
	subq.w	#1,d7

	bra	seekAfter

xvdfv2MainLoop::				*a4,a5,a6,d7

	move.l	PCM_BLOCK_SIZE(a6),d0		* not View
	tst.w	ViewModeFlag(a6)
	beq	returnLoop

		move.w	ViewSeekNumber(a6),d1
		subq.w	#1,d1
@@:
			add.l	(a5)+,d0
			add.l	PCM_BLOCK_SIZE(a6),d0
			dbra	d1,@B

returnLoop::
	move.w	#1,-(sp)			*
	move.l	d0,-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				* $FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

seekAfter::
	move.l	(a5)+,-(sp)
	move.l	pImage(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				* $FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

	move.l	pImage(a6),a0
	move.l	(a4)+,a1
	move.l	DrawRoutine(a6),a2

	movem.l	d7/a4-a5,-(sp)
	jsr	(a2)				* data draw
	movem.l	(sp)+,d7/a4-a5

		move.l	(sp)+,a1
		IOCS	_B_SUPER

	dbra	d7,xvdfv2MainLoop

**************************
**	exit		**
**************************
END::
	move.w	FileHundle(a6),-(sp)
	DOS	_CLOSE
	addq.l	#2,sp

	DOS	_EXIT



******************************************************************
**			SVDFV3 Mode				**
******************************************************************
SVDFV3Mode::

	move.l	ImageSize(a6),d0
	add.l	d0,d0
	move.l	d0,-(sp)
	DOS	_MALLOC				*$FF48
	addq.l	#4,sp

		bmi	MallocError

	move.l	d0,pImageData(a6)		* to VRAM
	add.l	ImageSize(a6),d0
	move.l	d0,pTempBuff(a6)

	movea.l	d0,a0
	move.l	ImageSize(a6),d0
	subq.l	#1,d0

@@:
	clr.b	(a0)+				*
	subq.l	#1,d0
	bne	@B

	move.w	Y_LENGTH+2(a6),d0
	move.w	d0,d1
	lsr.w	#4,d0				*/16
	ori.w	#$000f,d1
	beq	@F
	addq.w	#1,d0
@@:
	move.w	d0,Yhight(a6)

**************************
**	Data Seek	**
**************************

	move.l	pImageSizeTable(a6),a0
	move.l	DATA_OFFSET(a6),d0
	move.w	JumpFrameNumber(a6),d1
	beq	1F
	subq.w	#1,d1
@@:
		add.l	(a0)+,d0
		add.l	PCM_BLOCK_SIZE(a6),d0
		dbra	d1,@B
1:
	move.l	d0,SeekSize(a6)

	move.w	#0,-(sp)			*t@C擪̈ړ
	move.l	d0,-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	(a0),-(sp)			*TCY
	move.l	pImageData(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

**************************
**	Display		**
**************************

	IOCS	_OS_CUROF			*$af
	move.w	#-1,d1
	IOCS	_CRTMOD
	move.w	d0,CrtmodeBuff(a6)		* keep


X68kOriginalData::
	move.w	#2,CrtmodeFlag(a6)		* 256x256

	move.w	#$000C,d1
	IOCS	_CRTMOD
	IOCS	_G_CLR_ON

	tst.l	ASPECT_RATIO(a6)
	beq	SquareData

	cmpi.w	#512,X_LENGTH+2(a6)
	bne	@F
	cmpi.w	#240,Y_LENGTH+2(a6)
	beq	X68k512x256
	cmpi.w	#256,Y_LENGTH+2(a6)
	bne	@F

X68k512x256::
	move.w	#4,CrtmodeFlag(a6)		* 512x240

		suba.l	a1,a1
		IOCS	_B_SUPER

	move.w	#$0311,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600

		move.l	d0,a1
		IOCS	_B_SUPER

	move.w	#$000f,Yhight(a6)
	bra	CrtmodeFinish

SquareData::
	clr.w	CrtmodeFlag(a6)			* 384x256

	move.w	#$0110,d1
	IOCS	_CRTMOD

		suba.l	a1,a1
		IOCS	_B_SUPER

	move.w	#$0316,$00e8_0028
	move.w	#$0003,$00e8_2400
	move.w	#$002f,$00e8_2600

		move.l	d0,a1
		IOCS	_B_SUPER

@@:
	cmpi.l	#384,X_LENGTH(a6)
	bhi	CrtmodeFinish
	cmpi.w	#256,Y_LENGTH+2(a6)
	bhi	CrtmodeFinish

	add.w	#1,CrtmodeFlag(a6)
	bsr	CrtmodeChange

CrtmodeFinish::

**************************
**	Text		**
**************************

		suba.l	a1,a1
		IOCS	_B_SUPER

	lea.l	$e82200,a0			*KEEP Text Palet
	lea.l	TextPaletBuff(a6),a1
	lea.l	TextPalet(pc),a2

	moveq.l	#8-1,d7
@@:
	move.l	(a0),(a1)+
	move.l	(a2)+,(a0)+
	dbra	d7,@B

		move.l	d0,a1
		IOCS	_B_SUPER

	lea.l	TextMask(pc),a1
	IOCS	_TXFILL

**************************
**	ʒu	**
**************************

	move.l	#$00c0_0000,a1
*	moveq.l	#0,d0				* Ƃ肠ۑ
*	move.w	XNumber(a6),d0
*	add.w	d0,d0
*	add.l	d0,a1
*	moveq.l	#0,d0
*	move.w	YNumber(a6),d0
*	add.l	d0,d0
*	add.l	d0,d0
*	lsl.l	#8,d0
*	adda.l	d0,a1

	move.l	a1,VRAMAddress(a6)

		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

	move.l	pImageData(a6),a0
	move.l	VRAMAddress(a6),a1
	move.l	DrawRoutine(a6),a2
	jsr	(a2)				* data draw

		move.l	(sp)+,a1
		IOCS	_B_SUPER

	move.w	JumpFrameNumber(a6),d0
	move.w	d0,CurrentNumber(a6)
	lea.l	StrBuf(a6),a0
	bsr	DEC2STR

	lea.l	StrBuf(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

******************************************************************
**				KEY				**
******************************************************************

KeyLoop::
	IOCS	_B_KEYSNS			* $01
	tst.l	d0				* ̃[v͒PȂEFCg
	beq	KeyLoop	

	clr.w	TabFlag(a6)			*Tab
	clr.w	CtrlFlag(a6)			*Ctrl

		suba.l	a1,a1
		IOCS	_B_SUPER

	move.l	$0000_800,d1
	move.l	$0000_804,d2
	move.l	$0000_808,d3
	move.l	$0000_80c,d4

		move.l	d0,a1
		IOCS	_B_SUPER

	move.l	d1,d0
	andi.l	#$0200_0000,d0
	bne	SVDFV3End			*ESC
	move.w	d1,d0
	andi.w	#$0100,d0
	move.w	d0,TabFlag(a6)			*Tab
	move.w	d4,d0
	andi.w	#$0200,d0
	move.w	d0,CtrlFlag(a6)			*Ctrl

	move.w	d2,d0
	andi.w	#$0002,d0			* ROLL DN
	bne	rollDown
	move.w	d2,d0
	andi.w	#$0001,d0			* ROLL UP
	bne	rollUp

	move.w	d2,d0
	andi.w	#$0040,d0			* 
	bne	downCursol
	move.w	d2,d0
	andi.w	#$0020,d0			* 
	bne	rightCursol
	move.w	d2,d0
	andi.w	#$0010,d0			* 
	bne	upCursol
	move.w	d2,d0
	andi.w	#$0008,d0			* 
	bne	leftCursol


	move.w	d1,d0				* P
	andi.w	#$0004,d0
	bne	PlayData

	move.l	d2,d0				* B
	andi.l	#$0040_0000,d0
	bne	BenchMark

	move.l	d2,d0				* Z
	andi.l	#$0004_0000,d0
	bne	ZoomDisplay

	move.l	d2,d0				* H
	andi.l	#$0800_0000,d2
	bne	HalfDisplay

	move.l	IMAGE_TYPE(a6),d0
	andi.l	#$7fff_ffff,d0			* InterLace
	bne	KeyLoopEnd

	move.l	d2,d0
	andi.l	#$0010_0000,d0			* C
	bne	Copy2Memory

	move.w	d1,d0
	andi.w	#$0400,d0			* W
	bne	Write2Disk

KeyLoopEnd::
	move.w	#-1,-(sp)
	DOS	_KFLUSH				*L[obt@
	addq.l	#2,sp
	bra	KeyLoop

******************************************************************
**			KEY Branch				**
******************************************************************

**************************
**	ROLL DOWN	**
**************************
rollDown::				* +100
	moveq.l	#100,d0
	tst.w	CtrlFlag(a6)
	beq	@F
	move.w	#$ffff,d0		* End Frame
@@:
	tst.w	TabFlag(a6)
	beq	@F
	move.w	#$ffff,d0		* End Frame
@@:
	bsr	plusFrameSeek
	bra	dispKeyLoop

**************************
**	ROLL UP	**
**************************
rollUp::				* -100
	moveq.l	#100,d0
	tst.w	CtrlFlag(a6)
	beq	@F
	move.w	#$ffff,d0		* First Frame
@@:
	tst.w	TabFlag(a6)
	beq	@F
	move.w	#$ffff,d0		* First Frame
@@:
	bsr	minusFrameSeek
	bra	dispKeyLoop

**************************
**	RIGHT		**
**************************
rightCursol::				* +1
	moveq.l	#1,d0
	tst.w	CtrlFlag(a6)
	beq	@F
	moveq.l	#10,d0			* +10

	tst.w	TabFlag(a6)
	beq	ExecRightCursol
	move.w	#$ffff,d0		* last
	bra	ExecRightCursol

@@:
	tst.w	TabFlag(a6)
	beq	ExecRightCursol
	moveq.l	#100,d0			* +100

ExecRightCursol::
	bsr	plusFrameSeek
	bra	dispKeyLoop

**************************
**	LEFT	**
**************************
leftCursol::				* -1
	moveq.l	#1,d0
	tst.w	CtrlFlag(a6)
	beq	@F

	moveq.l	#10,d0			* -10
	tst.w	TabFlag(a6)
	beq	ExecLeftCursol
	move.w	#$ffff,d0		* last
	bra	ExecLeftCursol

@@:
	tst.w	TabFlag(a6)
	beq	ExecLeftCursol
	moveq.l	#100,d0			* -100

ExecLeftCursol::
	bsr	minusFrameSeek
	bra	dispKeyLoop

**************************
**	DOWN		**
**************************
downCursol::				* -10
	moveq.l	#10,d0
	tst.w	CtrlFlag(a6)
	beq	@F

	moveq.l	#100,d0			* -100
	tst.w	TabFlag(a6)
	beq	ExecDownCursol
	move.w	#$ffff,d0		* last
	bra	ExecDownCursol

@@:
	tst.w	TabFlag(a6)
	beq	ExecDownCursol
	move.w	#1000,d0		* -1000

ExecDownCursol::
	bsr	minusFrameSeek
	bra	dispKeyLoop

**************************
**	UP		**
**************************
upCursol::				* +10
	moveq.l	#10,d0
	tst.w	CtrlFlag(a6)
	beq	@F
	moveq.l	#100,d0			* +10

	tst.w	TabFlag(a6)
	beq	ExecUpCursol
	move.w	#$ffff,d0		* last
	bra	ExecUpCursol

@@:
	tst.w	TabFlag(a6)
	beq	ExecUpCursol
	move.w	#1000,d0			* +100

ExecUpCursol::
	bsr	plusFrameSeek
	bra	dispKeyLoop

**************************
**	display		**
**************************
dispKeyLoop::
		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

	move.l	pImageData(a6),a0
	move.l	VRAMAddress(a6),a1
	move.l	DrawRoutine(a6),a2
	jsr	(a2)				* data draw

		move.l	(sp)+,a1
		IOCS	_B_SUPER

	move.w	CurrentNumber(a6),d0
	lea.l	StrBuf(a6),a0
	bsr	DEC2STR

	lea.l	StrBuf(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	bra	KeyLoopEnd

**********************************
**	Copy to Mermory		**
**********************************
Copy2Memory::
		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,d7

	move.l	pImageData(a6),a0
	move.l	pTempBuff(a6),a1

	move.l	ImageSize(a6),d0
	lsr.l	#2,d0				*/4
	subq.l	#1,d0
@@:
	move.l	(a0)+,(a1)+
	subq.l	#1,d0
	bne	@B

		move.l	d7,a1
		IOCS	_B_SUPER

	bra	KeyLoopEnd

**********************************
**	Write to Disk		**
**********************************
Write2Disk::
	move.l	ImageSize(a6),d0
	add.l	PCM_BLOCK_SIZE(a6),d0
	neg.l	d0

	move.w	#1,-(sp)			*̏ꂩ
	move.l	d0,-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	move.l	ImageSize(a6),-(sp)
	move.l	pTempBuff(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_WRITE
	lea.l	10(sp),sp

		tst.l	d0
		bmi	WriteError

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

	move.l	pTempBuff(a6),a0
	move.l	VRAMAddress(a6),a1
	move.l	DrawRoutine(a6),a2
	jsr	(a2)				* data draw

		move.l	(sp)+,a1
		IOCS	_B_SUPER

	bra	KeyLoopEnd

******************************************************************
**			Play Data				**
******************************************************************
PlayData::
	move.l	FRAME_NUMBER(a6),d7
	sub.w	CurrentNumber(a6),d7
	subq.l	#2,d7
	bcs	KeyLoopEnd

	moveq.l	#0,d1
	move.w	CurrentNumber(a6),d1
	addq.l	#1,d1				*Jg̎
	add.l	d1,d1
	add.l	d1,d1			* x4
	movea.l	pImageSizeTable(a6),a3
	adda.l	d1,a3

		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

PlayLoop::
	move.l	(a3)+,-(sp)			*TCY
	move.l	pImageData(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	add.w	#1,CurrentNumber(a6)

	move.l	pImageData(a6),a0
	move.l	VRAMAddress(a6),a1
	move.l	DrawRoutine(a6),a2

0:	btst.b	#4,$E88001
	beq	0b
0:	btst.b	#4,$E88001
	bne	0b
0:	btst.b	#4,$E88001
	bne	0b

	movem.l	d0-d7/a0-a6,-(sp)
	jsr	(a2)				* data draw
	movem.l	(sp)+,d0-d7/a0-a6

	move.w	CurrentNumber(a6),d0
	lea.l	StrBuf(a6),a0
	bsr	DEC2STR

	lea.l	StrBuf(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	tst.b	$800
	bne	PlayDataEnd
	tst.b	$806
	bne	PlayDataEnd

	dbra	d7,PlayLoop

PlayDataEnd::
		move.l	(sp)+,a1
		IOCS	_B_SUPER

	bra	KeyLoopEnd

******************************************************************
**			Bench mark				**
******************************************************************
BenchMark::
	move.l	FRAME_NUMBER(a6),d7
	sub.w	CurrentNumber(a6),d7
	cmpi.l	#101,d7
	bcs	BenchMarkEnd

	lea.l	Keisoku(pc),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$6-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	moveq.l	#0,d1
	move.w	CurrentNumber(a6),d1
	addq.l	#1,d1				*Jg̎
	add.l	d1,d1
	add.l	d1,d1			* x4
	movea.l	pImageSizeTable(a6),a3
	adda.l	d1,a3

	moveq.l	#100-1,d7

	IOCS	_ONTIME
	move.l	d0,-(sp)

		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

BenchLoop::
	move.l	(a3)+,-(sp)			*TCY
	move.l	pImageData(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				*FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.w	#1,-(sp)			*̏ꂩ
	move.l	PCM_BLOCK_SIZE(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				*$FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	add.w	#1,CurrentNumber(a6)

	move.l	pImageData(a6),a0
	move.l	VRAMAddress(a6),a1
	move.l	DrawRoutine(a6),a2

*0:	btst.b	#4,$E88001
*	beq	0b
*0:	btst.b	#4,$E88001
*	bne	0b
*0:	btst.b	#4,$E88001
*	bne	0b

	movem.l	d0-d7/a3-a6,-(sp)
	jsr	(a2)				* data draw
	movem.l	(sp)+,d0-d7/a3-a6

	tst.b	$800
	bne	BenchMarkEnd
	tst.b	$806
	bne	BenchMarkEnd

	dbra	d7,BenchLoop

BenchMarkEnd::

		move.l	(sp)+,a1
		IOCS	_B_SUPER

	IOCS	_ONTIME
	move.l	(sp)+,d1
	sub.l	d1,d0

	move.l	#10000,d1
	moveq.l	#0,d2
	cmp.l	d0,d1
	bcs	CONMA_1
ZERO::
	addq.l	#1,d2				*d2:l
	sub.l	d0,d1
	cmp.l	d0,d1
	bcc	ZERO

CONMA_1::					*_P
	move.l	d1,d3				*d1:]
	lsl.l	#3,d1
	add.l	d3,d3
	add.l	d3,d1				*d1 x10
	moveq.l	#0,d3

	cmp.l	d0,d1
	bcs	CONMA_2
ZERO_1::
	addq.l	#1,d3				*d3:
	sub.l	d0,d1
	cmp.l	d0,d1
	bcc	ZERO_1

CONMA_2::					*_Q
	move.l	d1,d4
	lsl.l	#3,d1
	add.l	d4,d4
	add.l	d4,d1				*d1 x10
	moveq.l	#0,d4
	cmp.l	d0,d1
	bcs	CONMA_2
ZERO_2::
	addq.l	#1,d4				*d4:
	sub.l	d0,d1
	cmp.l	d0,d1
	bcc	ZERO_2

	move.w	d2,d0
	lea.l	StrBuf(a6),a0
	bsr	DEC2STR

	lea.l	StrBuf(a6),a0
	addq.l	#5,a0
	move.b	#'.',(a0)+
	add.b	#$30,d3
	move.b	d3,(a0)+
	add.b	#$30,d4
	move.b	d4,(a0)+
	clr.b	(a0)

	lea.l	White(pc),a1			*v폜
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$6-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	StrBuf(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$8-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	Fps(pc),a1
	moveq.l	#$3,d1				*
*	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$3-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	move.w	#-1,-(sp)
	DOS	_KFLUSH				*L[obt@
	addq.l	#2,sp
@@:
	IOCS	_B_KEYSNS
	tst.l	d0
	beq	@B

	lea.l	White(pc),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$12-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	lea.l	StrBuf(a6),a0
	move.w	CurrentNumber(a6),d0
	bsr	DEC2STR

	lea.l	StrBuf(a6),a1
	moveq.l	#$3,d1				*
	moveq.l	#$0,d2				*X
	move.w	Yhight(a6),d3			*Y
	moveq.l	#$5-1,d4
	IOCS	_B_PUTMES			*$2F	*d0,d4,d2.w,a1j

	bra	KeyLoopEnd

**********************************
**	Zoom Display		**
**********************************
ZoomDisplay::
	move.w	CrtmodeFlag(a6),d0
	add.w	d0,d0
	move.w	ZoomTable(pc,d0.w),CrtmodeFlag(a6)
	bsr	CrtmodeChange
	bra	KeyLoopEnd

ZoomTable::
	.dc.w	1		* 768 x 512
	.dc.w	0		* 384 x 256
	.dc.w	3		* 512 x 512
	.dc.w	2		* 256 x 256
	.dc.w	0		* 512 x 384
	.dc.w	2		* 512 x 256

	.quad

**********************************
**	Half Display		**
**********************************
HalfDisplay::
	move.w	CrtmodeFlag(a6),d0
	add.w	d0,d0
	move.w	HalfTable(pc,d0.w),CrtmodeFlag(a6)
	bsr	CrtmodeChange
	bra	KeyLoopEnd

HalfTable::
	.dc.w	5		*768x512
	.dc.w	5		*384x256
	.dc.w	4		*512x512
	.dc.w	4		*256x256
	.dc.w	2		*512x256
	.dc.w	0		*512x384

	.quad

******************************************************************
**			SVDFV3 END				**
******************************************************************
SVDFV3End::

	lea.l	TextMaskClr(pc),a1
	IOCS	_TXFILL

		suba.l	a1,a1
		IOCS	_B_SUPER

	lea.l	$e82200,a0			*KEEP Text Palet
	lea.l	TextPaletBuff(a6),a1
	moveq.l	#8-1,d7
@@:
	move.l	(a1)+,(a0)+
	dbra	d7,@B

		move.l	d0,a1
		IOCS	_B_SUPER

	IOCS	_OS_CURON			*$ae
	move.w	CrtmodeBuff(a6),d1
	IOCS	_CRTMOD

	move.w	FileHundle(a6),-(sp)
	DOS	_CLOSE
	addq.l	#2,sp

	DOS	_EXIT

******************************************************************
**			Error Routine				**
******************************************************************

NotXvdData::
	pea.l	NotXvdDataMes(pc)
	bra	ErrorPrint
FrameNumberError::
	pea.l	FrameNumberErrorMes(pc)
	bra	ErrorPrint
NotRev2::
	pea.l	NotRev2Mes(pc)
	bra	ErrorPrint
OverXNumber::
	pea.l	OverXNumberMes(pc)
	bra	ErrorPrint
OverYNumber::
	pea.l	OverYNumberMes(pc)
	bra	ErrorPrint
ImageTypeError::
	pea.l	ImageTypeErrorMes(pc)
	bra	ErrorPrint
ViewNumberError::
	pea.l	ViewNumberErrorMes(pc)
	bra	ErrorPrint
OpenError::
	pea.l	OpenErrorMes(pc)
	bra	ErrorPrint
ReadError::
	pea.l	ReadErrorMes(pc)
	bra	ErrorPrint
SeekError::
	pea.l	SeekErrorMes(pc)
	bra	ErrorPrint
WriteError::
	pea.l	WriteErrorMes(pc)
	bra	ErrorPrint
MallocError::
	pea.l	MallocErrorMes(pc)

ErrorPrint::
	DOS	_PRINT
	DOS	_EXIT

******************************************************************
**			Data Draw				**
******************************************************************
************************
* bufferVRAMɓ] *
* a1=]@a0=] *
************************
ImageType0::				*Normal
	move.w	YAT_YSIZE(a6),d0
	move.l	CULC_Y_LENGTH(a6),d1
	move.w	CULC_X_LENGTH(a6),d3

DrawVRAM0LP2::
		move.l	d3,d2
DrawVRAM0LP1::
		move.l	(a0)+,(a1)+
		dbra	d2,DrawVRAM0LP1

	adda.l	d1,a1			* =(512-X)x2
	dbra	d0,DrawVRAM0LP2
	rts

******************************************************************
**			VDP decode (a0 to a1)			**
******************************************************************
*************************************************
*		Normal Screen Draw		*
*************************************************
ImageType1::
	move.l	PackedTableSize(a6),d1
	move.l	(a0)+,d0			* d0 = Level Flag
	beq	@f
	move.l	d0,d1
@@:						* a0 = pbNhe[uobt@
						* a1 = ݃obt@
	lea.l	(a0,d1.l),a2			* a2 = J[obt@
	movea.l	pVdpDecodeBuff0(a6),a3		* a3 = Qƃobt@P
	movea.l	pVdpDecodeBuff1(a6),a4		* a4 = Qƃobt@Q

	move.w	#%0000_0000_1111_0000,d2	* d2 = }XNP
	move.w	#%0000_0000_0000_1111,d3	* d3 = }XNQ
	move.l	CULC_Y_LENGTH(a6),d4		* d4 = G-VRAMl
						* d6 = X Loop Counter
	move.w	YAT_YSIZE(a6),d7		* d7 = Y Loop Counter

	move.l	a3,pVdpDecodeBuff1(a6)
	move.l	a4,pVdpDecodeBuff0(a6)		* Qƃobt@

	tst.l	d0
	bne	VdpDecode0_2

***********
* Level 1 *
***********
VdpDecode0_1::
	move.w	CULC_X_LENGTH(a6),d5		* d5 = X_Loop
1:	move.w	d5,d6
2:		move.b	(a0)+,d0			* pbNhe[uǂݍ
		move.b	d0,d1
		and.w	d2,d0
		bne	20f
10:		move.w	(a2)+,d0			* J[obt@ǂݍ
		move.w	d0,(a4)+			* Qƃobt@Qɏ
		move.w	d0,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		and.w	d3,d1
		bne	21f
11:		move.w	(a2)+,d0			* J[obt@ǂݍ
		move.w	d0,(a4)+			* Qƃobt@Qɏ
		move.w	d0,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		dbra	d6,2b
12:	adda.l	d4,a1
	adda.l	d4,a3
	adda.l	d4,a4
	dbra	d7,1b
	rts

20:		cmpi.w	#9*16,d0
		bhi	30f
		move.w	VDP_TABLE0_1b.b(pc,d0.w),d0
		move.w	(a3,d0.w),d0			* Qƃobt@Pǂݍ
		move.w	d0,(a4)+			* Qƃobt@Qɏ
		move.w	d0,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		and.w	d3,d1
		beq	11b
21:		cmpi.w	#9,d1
		bhi	31f
22:		add.w	d1,d1
		move.w	VDP_TABLE0_1a.b(pc,d1.w),d0
		move.w	(a3,d0.w),d0			* Qƃobt@Pǂݍ
		move.w	d0,(a4)+			* Qƃobt@Qɏ
		move.w	d0,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		dbra	d6,2b
		bra	12b

30:		move.w	VDP_TABLE0_1b.b(pc,d0.w),d0
		move.w	(a4,d0.w),d0			* Qƃobt@Qǂݍ
		move.w	d0,(a4)+			* Qƃobt@Qɏ
		move.w	d0,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		and.w	d3,d1
		beq	11b
		cmpi.w	#9,d1
		bls	22b
31:		add.w	d1,d1
		move.w	VDP_TABLE0_1a.b(pc,d1.w),d0
		move.w	(a4,d0.w),d0			* Qƃobt@Qǂݍ
		move.w	d0,(a4)+			* Qƃobt@Qɏ
		move.w	d0,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		dbra	d6,2b
		bra	12b

VDP_TABLE0_1a::
	.dc.w	0
	.dc.w	-1024-2,-1024,-1024+2,-2,0,2,1024-2,1024,1024+2
	.dc.w	-2048,-1024-2,-1024,-1024+2,-4,-2

VDP_TABLE0_1b::
	.dc.w	0,0,0,0,0,0,0,0
	.dc.w	-1024-2,0,0,0,0,0,0,0
	.dc.w	-1024,0,0,0,0,0,0,0
	.dc.w	-1024+2,0,0,0,0,0,0,0
	.dc.w	-2,0,0,0,0,0,0,0
	.dc.w	0,0,0,0,0,0,0,0
	.dc.w	2,0,0,0,0,0,0,0
	.dc.w	1024-2,0,0,0,0,0,0,0
	.dc.w	1024,0,0,0,0,0,0,0
	.dc.w	1024+2,0,0,0,0,0,0,0
	.dc.w	-2048,0,0,0,0,0,0,0
	.dc.w	-1024-2,0,0,0,0,0,0,0
	.dc.w	-1024,0,0,0,0,0,0,0
	.dc.w	-1024+2,0,0,0,0,0,0,0
	.dc.w	-4,0,0,0,0,0,0,0
	.dc.w	-2

	.quad
***********
* Level 2 *
***********
VdpDecode0_2::
	clr.w	d1				* d1 = OX[vJE^
1:	move.w	CULC_X_LENGTH(a6),d6
2:		subq.w	#1,d1
		bcs	40f
10:		move.w	(a3,d0.w),d5			* Qƃobt@Pǂݍ
		move.w	d5,(a4)+			* Qƃobt@Qɏ
		move.w	d5,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		subq.w	#1,d1
		bcs	50f
11:		move.w	(a3,d0.w),d5			* Qƃobt@Pǂݍ
		move.w	d5,(a4)+			* Qƃobt@Qɏ
		move.w	d5,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		dbra	d6,2b
	adda.l	d4,a1
	adda.l	d4,a3
	adda.l	d4,a4
	dbra	d7,1b
	rts

1:	move.w	CULC_X_LENGTH(a6),d6
2:		subq.w	#1,d1
		bcs	40f
20:		move.w	(a4,d0.w),d5			* Qƃobt@Qǂݍ
		move.w	d5,(a4)+			* Qƃobt@Qɏ
		move.w	d5,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		subq.w	#1,d1
		bcs	50f
21:		move.w	(a4,d0.w),d5			* Qƃobt@Qǂݍ
		move.w	d5,(a4)+			* Qƃobt@Qɏ
		move.w	d5,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		dbra	d6,2b
	adda.l	d4,a1
	adda.l	d4,a3
	adda.l	d4,a4
	dbra	d7,1b
	rts

1:	move.w	CULC_X_LENGTH(a6),d6
2:		subq.w	#1,d1
		bcs	40f
30:		move.w	(a2)+,d5			* J[obt@ǂݍ
		move.w	d5,(a4)+			* Qƃobt@Qɏ
		move.w	d5,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		subq.w	#1,d1
		bcs	50f
31:		move.w	(a2)+,d5			* J[obt@ǂݍ
		move.w	d5,(a4)+			* Qƃobt@Qɏ
		move.w	d5,(a1)+			* G-VRAMɏ
		addq.l	#2,a3				* Qƃobt@PύX
		dbra	d6,2b
	adda.l	d4,a1
	adda.l	d4,a3
	adda.l	d4,a4
	dbra	d7,1b
	rts

40:		move.b	(a0)+,d0			* pbNhe[uǂݍ
		move.b	d0,d1
		and.w	d3,d1				* d1 = OX[v
		and.w	d2,d0
		beq	30b
		cmpi.w	#9*16,d0
		bhi	42f
41:		move.w	VDP_TABLE0_2.b(pc,d0.w),d0
		bra	10b
42:		move.w	VDP_TABLE0_2.b(pc,d0.w),d0
		bra	20b

50:		move.b	(a0)+,d0			* pbNhe[uǂݍ
		move.b	d0,d1
		and.w	d3,d1				* d1 = OX[v
		and.w	d2,d0
		beq	31b
		cmpi.w	#9*16,d0
		bhi	52f
51:		move.w	VDP_TABLE0_2.b(pc,d0.w),d0
		bra	11b
52:		move.w	VDP_TABLE0_2.b(pc,d0.w),d0
		bra	21b

VDP_TABLE0_2::
	.dc.w	0,0,0,0,0,0,0,0
	.dc.w	-1024-2,0,0,0,0,0,0,0
	.dc.w	-1024,0,0,0,0,0,0,0
	.dc.w	-1024+2,0,0,0,0,0,0,0
	.dc.w	-2,0,0,0,0,0,0,0
	.dc.w	0,0,0,0,0,0,0,0
	.dc.w	2,0,0,0,0,0,0,0
	.dc.w	1024-2,0,0,0,0,0,0,0
	.dc.w	1024,0,0,0,0,0,0,0
	.dc.w	1024+2,0,0,0,0,0,0,0
	.dc.w	-2048,0,0,0,0,0,0,0
	.dc.w	-1024-2,0,0,0,0,0,0,0
	.dc.w	-1024,0,0,0,0,0,0,0
	.dc.w	-1024+2,0,0,0,0,0,0,0
	.dc.w	-4,0,0,0,0,0,0,0
	.dc.w	-2
******************************************************************
**			YAT decode (a0 to a1)			**
******************************************************************
*************************************************
*		Normal Screen Draw		*
*************************************************
ImageType3::
	move.l	(a0)+,d1			* d1 = ibit size
	move.l	(a0)+,d2			* d2 = flag size
	move.l	(a0)+,d3			* d3 = diff size
						* a0 = Pxrbgobt@
						* a1 = ݃obt@
	lea.l	(a0,d1.l),a2			* a2 = tOobt@
	lea.l	(a2,d2.l),a3			* a3 = obt@
	lea.l	(a3,d3.l),a4			* a4 = J[obt@
	movea.l	CULC_Y_LENGTH(a6),a5		* a5 = G-VRAMl
						* d1 = Pxrbg
						* d2 = tO
	clr.w	d3				* d3 = counter
	clr.w	d4				* d4 = 
						* d5 = OF 
						* d6 = X Loop
	move.w	YAT_YSIZE(a6),d7		* d7 = Y Loop

	tst.l	d2
	beq	YatDecode0_F
	tst.l	d1
	beq	YatDecode0_N
	tst.w	FastDrawFlag(a6)
	bne	YatDecode0_N

*********
* I bit *
*********
YatDecode0_I::
						* d0 = [NWX^
1:	move.w	CULC_X_LENGTH(a6),d6
2:		subq.w	#1,d3
		bpl	@f				* d3<0
		move.l	(a0)+,d1			* ibit ǂݍ
		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#15,d3
@@:		add.l	d2,d2				* tOPȂAOF
		bcs	10f
		move.w	(a4)+,d5
		bpl	20f
10:		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂAOF
		bcs	11f
		move.w	(a4)+,d5
		bpl	21f
11:		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

3:	move.w	CULC_X_LENGTH(a6),d6
4:		subq.w	#1,d3
		bpl	@f				* d3<0
		move.l	(a0)+,d1			* ibit ǂݍ
		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#15,d3
@@:		add.l	d2,d2				* tOPȂAOF
		bcs	20f
		moveq.l	#0,d4
		move.b	(a3)+,d4			* ǂݍ
		bmi	30f				* 
		add.w	d4,d4
		add.w	YAT_TABLE_I.b(pc,d4.w),d5
20:		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂAOF
		bcs	21f
		moveq.l	#0,d4
		move.b	(a3)+,d4			* ǂݍ
		bmi	31f				* 
		add.w	d4,d4
		add.w	YAT_TABLE_I.b(pc,d4.w),d5
21:		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		dbra	d6,4b
	adda.l	a5,a1
	dbra	d7,3b
	rts

30:		add.w	d4,d4
		add.w	YAT_TABLE_I.b(pc,d4.w),d5
		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂAOF
		bcs	11b
		move.w	(a4)+,d5
		bpl	21b
		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

31:		add.w	d4,d4
		add.w	YAT_TABLE_I.b(pc,d4.w),d5
		move.w	d5,d0
		add.l	d1,d1				* Pxrbgo
		addx.w	d0,d0
		move.w	d0,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

*************************************************
*		YAT Table ( I bit )		*
*************************************************
YAT_TABLE_I::
	.dc.w	-2048-64-2,-2048-64-1,-2048-64,-2048-64+1,-2048-64+2
	.dc.w	-2048-32-2,-2048-32-1,-2048-32,-2048-32+1,-2048-32+2
	.dc.w	-2048-2,-2048-1,-2048,-2048+1,-2048+2
	.dc.w	-2048+32-2,-2048+32-1,-2048+32,-2048+32+1,-2048+32+2
	.dc.w	-2048+64-2,-2048+64-1,-2048+64,-2048+64+1,-2048+64+2
	.dc.w	-1024-64-2,-1024-64-1,-1024-64,-1024-64+1,-1024-64+2
	.dc.w	-1024-32-2,-1024-32-1,-1024-32,-1024-32+1,-1024-32+2
	.dc.w	-1024-2,-1024-1,-1024,-1024+1,-1024+2
	.dc.w	-1024+32-2,-1024+32-1,-1024+32,-1024+32+1,-1024+32+2
	.dc.w	-1024+64-2,-1024+64-1,-1024+64,-1024+64+1,-1024+64+2
	.dc.w	-64-2,-64-1,-64,-64+1,-64+2
	.dc.w	-32-2,-32-1,-32,-32+1,-32+2
	.dc.w	-2,-1,0,1,2
	.dc.w	32-2,32-1,32,32+1,32+2
	.dc.w	64-2,64-1,64,64+1,64+2
	.dc.w	1024-64-2,1024-64-1,1024-64,1024-64+1,1024-64+2
	.dc.w	1024-32-2,1024-32-1,1024-32,1024-32+1,1024-32+2
	.dc.w	1024-2,1024-1,1024,1024+1,1024+2
	.dc.w	1024+32-2,1024+32-1,1024+32,1024+32+1,1024+32+2
	.dc.w	1024+64-2,1024+64-1,1024+64,1024+64+1,1024+64+2
	.dc.w	2048-64-2,2048-64-1,2048-64,2048-64+1,2048-64+2
	.dc.w	2048-32-2,2048-32-1,2048-32,2048-32+1,2048-32+2
	.dc.w	2048-2,2048-1,2048,2048+1,2048+2
	.dc.w	2048+32-2,2048+32-1,2048+32,2048+32+1,2048+32+2
	.dc.w	2048+64-2,2048+64-1,2048+64,2048+64+1,2048+64+2
	.dc.w	0,0,0
	.dc.w	-2048-64-2,-2048-64-1,-2048-64,-2048-64+1,-2048-64+2
	.dc.w	-2048-32-2,-2048-32-1,-2048-32,-2048-32+1,-2048-32+2
	.dc.w	-2048-2,-2048-1,-2048,-2048+1,-2048+2
	.dc.w	-2048+32-2,-2048+32-1,-2048+32,-2048+32+1,-2048+32+2
	.dc.w	-2048+64-2,-2048+64-1,-2048+64,-2048+64+1,-2048+64+2
	.dc.w	-1024-64-2,-1024-64-1,-1024-64,-1024-64+1,-1024-64+2
	.dc.w	-1024-32-2,-1024-32-1,-1024-32,-1024-32+1,-1024-32+2
	.dc.w	-1024-2,-1024-1,-1024,-1024+1,-1024+2
	.dc.w	-1024+32-2,-1024+32-1,-1024+32,-1024+32+1,-1024+32+2
	.dc.w	-1024+64-2,-1024+64-1,-1024+64,-1024+64+1,-1024+64+2
	.dc.w	-64-2,-64-1,-64,-64+1,-64+2
	.dc.w	-32-2,-32-1,-32,-32+1,-32+2
	.dc.w	-2,-1,0,1,2
	.dc.w	32-2,32-1,32,32+1,32+2
	.dc.w	64-2,64-1,64,64+1,64+2
	.dc.w	1024-64-2,1024-64-1,1024-64,1024-64+1,1024-64+2
	.dc.w	1024-32-2,1024-32-1,1024-32,1024-32+1,1024-32+2
	.dc.w	1024-2,1024-1,1024,1024+1,1024+2
	.dc.w	1024+32-2,1024+32-1,1024+32,1024+32+1,1024+32+2
	.dc.w	1024+64-2,1024+64-1,1024+64,1024+64+1,1024+64+2
	.dc.w	2048-64-2,2048-64-1,2048-64,2048-64+1,2048-64+2
	.dc.w	2048-32-2,2048-32-1,2048-32,2048-32+1,2048-32+2
	.dc.w	2048-2,2048-1,2048,2048+1,2048+2
	.dc.w	2048+32-2,2048+32-1,2048+32,2048+32+1,2048+32+2
	.dc.w	2048+64-2,2048+64-1,2048+64,2048+64+1,2048+64+2

*************
* Not I bit *
*************
YatDecode0_N::
	move.w	CULC_X_LENGTH(a6),d0		* d0 = X Loop
1:	move.w	d0,d6
2:		subq.w	#1,d3
		bpl	@f				* d3<0
		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#15,d3
@@:		add.l	d2,d2				* tOPȂAOF
		bcs	10f
		move.w	(a4)+,d5
		add.w	d5,d5
		bcc	20f
10:		move.w	d5,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂAOF
		bcs	11f
		move.w	(a4)+,d5
		add.w	d5,d5
		bcc	21f
11:		move.w	d5,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

3:	move.w	d0,d6
4:		subq.w	#1,d3
		bpl	@f				* d3<0
		move.l	(a2)+,d2			* flag ǂݍ
		moveq.l	#15,d3
@@:		add.l	d2,d2				* tOPȂAOF
		bcs	20f
		moveq.l	#0,d4
		move.b	(a3)+,d4			* ǂݍ
		bmi	30f				* 
		add.w	d4,d4
		add.w	YAT_TABLE_N.b(pc,d4.w),d5
20:		move.w	d5,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂAOF
		bcs	21f
		moveq.l	#0,d4
		move.b	(a3)+,d4			* ǂݍ
		bmi	31f				* 
		add.w	d4,d4
		add.w	YAT_TABLE_N.b(pc,d4.w),d5
21:		move.w	d5,(a1)+			* GRAMɐFR[h
		dbra	d6,4b
	adda.l	a5,a1
	dbra	d7,3b
	rts

30:		add.w	d4,d4
		add.w	YAT_TABLE_N.b(pc,d4.w),d5
		move.w	d5,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂAOF
		bcs	11b
		move.w	(a4)+,d5
		add.w	d5,d5
		bcc	21b
		move.w	d5,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

31:		add.w	d4,d4
		add.w	YAT_TABLE_N.b(pc,d4.w),d5
		move.w	d5,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

*************************************************
*		YAT Table ( Not I bit )		*
*************************************************
YAT_TABLE_N::
	.dc.w	-4096-128-4,-4096-128-2,-4096-128,-4096-128+2,-4096-128+4
	.dc.w	-4096-64-4,-4096-64-2,-4096-64,-4096-64+2,-4096-64+4
	.dc.w	-4096-4,-4096-2,-4096,-4096+2,-4096+4
	.dc.w	-4096+64-4,-4096+64-2,-4096+64,-4096+64+2,-4096+64+4
	.dc.w	-4096+128-4,-4096+128-2,-4096+128,-4096+128+2,-4096+128+4
	.dc.w	-2048-128-4,-2048-128-2,-2048-128,-2048-128+2,-2048-128+4
	.dc.w	-2048-64-4,-2048-64-2,-2048-64,-2048-64+2,-2048-64+4
	.dc.w	-2048-4,-2048-2,-2048,-2048+2,-2048+4
	.dc.w	-2048+64-4,-2048+64-2,-2048+64,-2048+64+2,-2048+64+4
	.dc.w	-2048+128-4,-2048+128-2,-2048+128,-2048+128+2,-2048+128+4
	.dc.w	-128-4,-128-2,-128,-128+2,-128+4
	.dc.w	-64-4,-64-2,-64,-64+2,-64+4
	.dc.w	-4,-2,0,2,4
	.dc.w	64-4,64-2,64,64+2,64+4
	.dc.w	128-4,128-2,128,128+2,128+4
	.dc.w	2048-128-4,2048-128-2,2048-128,2048-128+2,2048-128+4
	.dc.w	2048-64-4,2048-64-2,2048-64,2048-64+2,2048-64+4
	.dc.w	2048-4,2048-2,2048,2048+2,2048+4
	.dc.w	2048+64-4,2048+64-2,2048+64,2048+64+2,2048+64+4
	.dc.w	2048+128-4,2048+128-2,2048+128,2048+128+2,2048+128+4
	.dc.w	4096-128-4,4096-128-2,4096-128,4096-128+2,4096-128+4
	.dc.w	4096-64-4,4096-64-2,4096-64,4096-64+2,4096-64+4
	.dc.w	4096-4,4096-2,4096,4096+2,4096+4
	.dc.w	4096+64-4,4096+64-2,4096+64,4096+64+2,4096+64+4
	.dc.w	4096+128-4,4096+128-2,4096+128,4096+128+2,4096+128+4
	.dc.w	0,0,0
	.dc.w	-4096-128-4,-4096-128-2,-4096-128,-4096-128+2,-4096-128+4
	.dc.w	-4096-64-4,-4096-64-2,-4096-64,-4096-64+2,-4096-64+4
	.dc.w	-4096-4,-4096-2,-4096,-4096+2,-4096+4
	.dc.w	-4096+64-4,-4096+64-2,-4096+64,-4096+64+2,-4096+64+4
	.dc.w	-4096+128-4,-4096+128-2,-4096+128,-4096+128+2,-4096+128+4
	.dc.w	-2048-128-4,-2048-128-2,-2048-128,-2048-128+2,-2048-128+4
	.dc.w	-2048-64-4,-2048-64-2,-2048-64,-2048-64+2,-2048-64+4
	.dc.w	-2048-4,-2048-2,-2048,-2048+2,-2048+4
	.dc.w	-2048+64-4,-2048+64-2,-2048+64,-2048+64+2,-2048+64+4
	.dc.w	-2048+128-4,-2048+128-2,-2048+128,-2048+128+2,-2048+128+4
	.dc.w	-128-4,-128-2,-128,-128+2,-128+4
	.dc.w	-64-4,-64-2,-64,-64+2,-64+4
	.dc.w	-4,-2,0,2,4
	.dc.w	64-4,64-2,64,64+2,64+4
	.dc.w	128-4,128-2,128,128+2,128+4
	.dc.w	2048-128-4,2048-128-2,2048-128,2048-128+2,2048-128+4
	.dc.w	2048-64-4,2048-64-2,2048-64,2048-64+2,2048-64+4
	.dc.w	2048-4,2048-2,2048,2048+2,2048+4
	.dc.w	2048+64-4,2048+64-2,2048+64,2048+64+2,2048+64+4
	.dc.w	2048+128-4,2048+128-2,2048+128,2048+128+2,2048+128+4
	.dc.w	4096-128-4,4096-128-2,4096-128,4096-128+2,4096-128+4
	.dc.w	4096-64-4,4096-64-2,4096-64,4096-64+2,4096-64+4
	.dc.w	4096-4,4096-2,4096,4096+2,4096+4
	.dc.w	4096+64-4,4096+64-2,4096+64,4096+64+2,4096+64+4
	.dc.w	4096+128-4,4096+128-2,4096+128,4096+128+2,4096+128+4

***************
* Fast Decode *
***************
YatDecode0_F::
	move.w	CULC_X_LENGTH(a6),d0		* d0 = X Loop
1:	move.w	d0,d6
2:		subq.w	#1,d3
		bpl	@f				* d3<0
		move.l	(a0)+,d2			* flag ǂݍ
		moveq.l	#15,d3
@@:		add.l	d2,d2				* tOPȂA
		bcc	20f
10:		moveq.l	#0,d4
		move.b	(a3)+,d4			* ǂݍ
		add.w	d4,d4
		add.w	YAT_TABLE_F.b(pc,d4.w),d5
		move.w	d5,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂA
		bcc	21f
11:		moveq.l	#0,d4
		move.b	(a3)+,d4			* ǂݍ
		add.w	d4,d4
		add.w	YAT_TABLE_F.b(pc,d4.w),d5
		move.w	d5,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts

20:		move.w	(a4)+,d5
		move.w	d5,(a1)+			* GRAMɐFR[h
		add.l	d2,d2				* tOPȂA
		bcs	11b
21:		move.w	(a4)+,d5
		move.w	d5,(a1)+			* GRAMɐFR[h
		dbra	d6,2b
	adda.l	a5,a1
	dbra	d7,1b
	rts
*************************************************
*		YAT Table ( Fast Decode )	*
*************************************************
YAT_TABLE_F:
	.dc.w	-4096-128-4,-4096-128-3,-4096-128-2,-4096-128-1,-4096-128
	.dc.w	-4096-128+1,-4096-128+2,-4096-128+3,-4096-128+4
	.dc.w	-4096-64-4,-4096-64-3,-4096-64-2,-4096-64-1,-4096-64
	.dc.w	-4096-64+1,-4096-64+2,-4096-64+3,-4096-64+4
	.dc.w	-4096-4,-4096-3,-4096-2,-4096-1,-4096
	.dc.w	-4096+1,-4096+2,-4096+3,-4096+4
	.dc.w	-4096+64-4,-4096+64-3,-4096+64-2,-4096+64-1,-4096+64
	.dc.w	-4096+64+1,-4096+64+2,-4096+64+3,-4096+64+4
	.dc.w	-4096+128-4,-4096+128-3,-4096+128-2,-4096+128-1,-4096+128
	.dc.w	-4096+128+1,-4096+128+2,-4096+128+3,-4096+128+4
	.dc.w	-2048-128-4,-2048-128-3,-2048-128-2,-2048-128-1,-2048-128
	.dc.w	-2048-128+1,-2048-128+2,-2048-128+3,-2048-128+4
	.dc.w	-2048-64-4,-2048-64-3,-2048-64-2,-2048-64-1,-2048-64
	.dc.w	-2048-64+1,-2048-64+2,-2048-64+3,-2048-64+4
	.dc.w	-2048-4,-2048-3,-2048-2,-2048-1,-2048
	.dc.w	-2048+1,-2048+2,-2048+3,-2048+4
	.dc.w	-2048+64-4,-2048+64-3,-2048+64-2,-2048+64-1,-2048+64
	.dc.w	-2048+64+1,-2048+64+2,-2048+64+3,-2048+64+4
	.dc.w	-2048+128-4,-2048+128-3,-2048+128-2,-2048+128-1,-2048+128
	.dc.w	-2048+128+1,-2048+128+2,-2048+128+3,-2048+128+4
	.dc.w	-128-4,-128-3,-128-2,-128-1,-128
	.dc.w	-128+1,-128+2,-128+3,-128+4
	.dc.w	-64-4,-64-3,-64-2,-64-1,-64
	.dc.w	-64+1,-64+2,-64+3,-64+4
	.dc.w	-4,-3,-2,-1,0
	.dc.w	1,2,3,4
	.dc.w	64-4,64-3,64-2,64-1,64
	.dc.w	64+1,64+2,64+3,64+4
	.dc.w	128-4,128-3,128-2,128-1,128
	.dc.w	128+1,128+2,128+3,128+4
	.dc.w	2048-128-4,2048-128-3,2048-128-2,2048-128-1,2048-128
	.dc.w	2048-128+1,2048-128+2,2048-128+3,2048-128+4
	.dc.w	2048-64-4,2048-64-3,2048-64-2,2048-64-1,2048-64
	.dc.w	2048-64+1,2048-64+2,2048-64+3,2048-64+4
	.dc.w	2048-4,2048-3,2048-2,2048-1,2048
	.dc.w	2048+1,2048+2,2048+3,2048+4
	.dc.w	2048+64-4,2048+64-3,2048+64-2,2048+64-1,2048+64
	.dc.w	2048+64+1,2048+64+2,2048+64+3,2048+64+4
	.dc.w	2048+128-4,2048+128-3,2048+128-2,2048+128-1,2048+128
	.dc.w	2048+128+1,2048+128+2,2048+128+3,2048+128+4
	.dc.w	4096-128-4,4096-128-3,4096-128-2,4096-128-1,4096-128
	.dc.w	4096-128+1,4096-128+2,4096-128+3,4096-128+4
	.dc.w	4096-64-4,4096-64-3,4096-64-2,4096-64-1,4096-64
	.dc.w	4096-64+1,4096-64+2,4096-64+3,4096-64+4
	.dc.w	4096-4,4096-3,4096-2,4096-1,4096
	.dc.w	4096+1,4096+2,4096+3,4096+4
	.dc.w	4096+64-4,4096+64-3,4096+64-2,4096+64-1,4096+64
	.dc.w	4096+64+1,4096+64+2,4096+64+3,4096+64+4
	.dc.w	4096+128-4,4096+128-3,4096+128-2,4096+128-1,4096+128
	.dc.w	4096+128+1,4096+128+2,4096+128+3,4096+128+4

	.quad
**********************************
**	plusFrameSeek		**
**********************************
plusFrameSeek::					*  d0:t[ $ffff:last

	move.w	FRAME_NUMBER+2(a6),d1
	subq.w	#1,d1
	cmp.w	CurrentNumber(a6),d1
	bne	@F
	rts
@@:
	moveq.l	#0,d1
	move.w	CurrentNumber(a6),d1
	addq.l	#1,d1				*Jg̎
	add.l	d1,d1
	add.l	d1,d1			* x4
	movea.l	pImageSizeTable(a6),a0
	adda.l	d1,a0

	cmpi.w	#$ffff,d0
	beq	plusfinalFrameSet

	add.w	d0,CurrentNumber(a6)	*

	move.w	CurrentNumber(a6),d1
	move.w	FRAME_NUMBER+2(a6),d2
	sub.w	d1,d2
	bhi	plusNext

	sub.w	d0,CurrentNumber(a6)

plusfinalFrameSet::
	move.w	CurrentNumber(a6),d1
	move.w	FRAME_NUMBER+2(a6),d2
	sub.w	d1,d2
	subq.w	#1,d2
	move.w	d2,d0
	move.w	FRAME_NUMBER+2(a6),d1
	subq.w	#1,d1
	move.w	d1,CurrentNumber(a6)

plusNext::
	subq.l	#1,d0
	beq	plusRead
	subq.l	#1,d0

	moveq.l	#0,d2
@@:
	add.l	(a0)+,d2
	add.l	PCM_BLOCK_SIZE(a6),d2
	dbra	d0,@B

	move.w	#1,-(sp)
	move.l	d2,-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				* $FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

plusRead::
	move.l	(a0),-(sp)			* Size
	move.l	pImageData(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				* $FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.w	#1,-(sp)
	move.l	PCM_BLOCK_SIZE(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				* $FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	rts

**********************************
**	minusFrameSeek		**
**********************************
minusFrameSeek::			*  d0:t[ $ffff:last

	tst.w	CurrentNumber(a6)
	bne	@F
	rts
@@:
	moveq.l	#0,d1
	move.w	CurrentNumber(a6),d1
	add.l	#1,d1				*
	add.l	d1,d1
	add.l	d1,d1			* x4
	movea.l	pImageSizeTable(a6),a0
	adda.l	d1,a0				*

	cmpi.w	#$ffff,d0
	bne	minusNotFirst

	clr.w	CurrentNumber(a6)
	movea.l	pImageSizeTable(a6),a0

	move.w	#0,-(sp)
	move.l	DATA_OFFSET(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				* $FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	bra	minusRead


minusNotFirst:
	move.w	CurrentNumber(a6),d1
	sub.w	d0,CurrentNumber(a6)

	cmp.w	d1,d0
	bmi	minusNext

	add.w	d0,CurrentNumber(a6)
	move.w	CurrentNumber(a6),d0
	clr.w	CurrentNumber(a6)

minusNext::
	moveq.l	#0,d2
@@:
	add.l	PCM_BLOCK_SIZE(a6),d2
	add.l	-(a0),d2
	dbra	d0,@B

	neg.l	d2

	move.w	#1,-(sp)
	move.l	d2,-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				* $FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

minusRead::
	move.l	(a0),-(sp)			* Size
	move.l	pImageData(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_READ				* $FF3F
	lea.l	10(sp),sp

		tst.l	d0
		bmi	ReadError

	move.w	#1,-(sp)
	move.l	PCM_BLOCK_SIZE(a6),-(sp)
	move.w	FileHundle(a6),-(sp)
	DOS	_SEEK				* $FF42
	addq.l	#8,sp

		tst.l	d0
		bmi	SeekError

	rts

**********************************
**	Crtmode Change		**
**********************************

CrtmodeChange::

*	CrtmodeFlag(a6)
*	0:768x512		1:384x256	5:512x384
*	2:512x512		3:256x256	4:512x256

	move.w	CrtmodeFlag(a6),d0
	add.w	d0,d0
	add.w	d0,d0
	movea.l	CrtmodeTable(pc,d0.w),a0

		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,-(sp)

0:	btst.b	#4,$E88001
	beq	0b
0:	btst.b	#4,$E88001
	bne	0b
0:	btst.b	#4,$E88001
	bne	0b

	lea.l	$00e8_0000,a1
	moveq.l	#8-1,d0
@@:
	move.w	(a0)+,(a1)+		* R0`R7
	dbra	d0,@B
	move.w	(a0)+,$00e8_0028	* R20

	tst.w	(a0)
	beq	@F
	bset.b	#1,$E8E007		* HRL
@@:

0:	btst.b	#4,$E88001
	beq	0b
0:	btst.b	#4,$E88001
	bne	0b
0:	btst.b	#4,$E88001
	bne	0b

		move.l	(sp)+,a1
		IOCS	_B_SUPER

	rts

CrtmodeTable::
	.dc.l	To768x512
	.dc.l	To384x256
	.dc.l	To512x512
	.dc.l	To256x256
	.dc.l	To512x256
	.dc.l	To512x384

******************************************
**		Dec to Str		**
******************************************

DEC2STR::					*d0.w to a0
	movem.l	d1-d3/a1-a2,-(sp)
	lea.l	DEC_TABLE(pc),a1
	move.l	a0,a2
DEC2STR_START::
	move.w	(a1)+,d1
	beq	EXIT
	moveq.l	#$00,d2
@@:
	move.w	d0,d3
	sub.w	d1,d0
	bcs	1f
	addq.l	#1,d2
	bra	@b
1:
	move.w	d3,d0
	addi.b	#'0',d2
	move.b	d2,(a0)+
	bra	DEC2STR_START

EXIT::
	move.b	#$00,(a0)+

* zero suppress
	move.l	a2,a0
@@:
	move.b	(a0)+,d0
	tst.b	d0
	beq	SPECIAL
	cmpi.b	#'0',d0
	bne	@f
	move.b	#SPACE,-1(a0)
	bra	@b

SPECIAL::
	subq.l	#2,a0
	cmpi.b	#SPACE,(a0)
	bne	@f
	move.b	#'0',(a0)
@@:
	movem.l	(sp)+,d1-d3/a1-a2
	rts

	.quad

DEC_TABLE::
	.dc.w	10000
	.dc.w	1000
	.dc.w	100
	.dc.w	10
	.dc.w	1
	.dc.w	0

*****************************
* IvV̔&򏈗 *
*****************************
SetOption::
	movem.l	d7/a3-a4,-(sp)
	clr.l	d7
	lea.l	OPTIONS(pc),a4
NextCheck::
	movea.l	a2,a3
CheckContinue::
	cmpm.b	(a4)+,(a3)+
	bne	NextMatch
	cmpi.b	#$00,(a4)
	beq	JumpOption
	bra	CheckContinue
NextMatch::
	addq.l	#1,d7
SkipOption::
	tst.b	(a4)+
	bne	SkipOption
	tst.b	(a4)
	beq	IreagalOption
	bra	NextCheck
JumpOption::
	lea.l	OPTION_TABLE(pc),a5
	lsl.l	#2,d7
	movea.l	$00(a5,d7.l),a5
	jsr	(a5)
	movea.l	a3,a2
	movem.l	(sp)+,d7/a3-a4
	moveq.l	#$00,d0
	rts
IreagalOption::
	movem.l	(sp)+,d7/a3-a4
	moveq.l	#$ff,d0
	rts


Asc2int::
	movem.l	d1-d2,-(sp)
	moveq.l	#0,d0
	moveq.l	#0,d1
GetAsc2int::
	tst.b	(a3)
	beq	Asc2intEnd
	cmpi.b	#SPACE,(a3)
	beq	Asc2intEnd
	cmpi.b	#',',(a3)
	beq	BeforeAsc2intEnd
	move.l	d0,d2
	add.l	d0,d0
	lsl.l	#3,d2
	add.l	d2,d0
	move.b	(a3)+,d1
	subi.b	#$30,d1
	add.l	d1,d0
	bra	GetAsc2int
BeforeAsc2intEnd::
	tst.b	(a3)
	beq	Asc2intEnd
	addq.l	#1,a3			*ی

Asc2intEnd::
	movem.l	(sp)+,d1-d2
	rts


**********************
* Option Sub Routine *
**********************
SetLoadPoint::
	cmpi.b	#SPACE,(a2)
	bne	@F
	move.w	#1,OneFrameFlag(a6)
	rts

@@:	bsr	Asc2int
	move.w	d0,XNumber(a6)
	bsr	Asc2int
	move.w	d0,YNumber(a6)
	rts

SetFrameNumber::
	bsr	Asc2int
	move.w	d0,JumpFrameNumber(a6)
	move.w	#1,PosterFlag(a6)
	rts

SetSVDFV3Mode::
	move.w	#1,SVDFV3ModeFlag(a6)
	move.w	#1,PosterFlag(a6)
	rts

SetViewMode::
	move.w	#1,ViewModeFlag(a6)
	move.w	#1,PosterFlag(a6)
	rts

SetFastDrawMode::
	move.w	#1,FastDrawFlag(a6)
	rts

SetStartNumber::
	bsr	Asc2int
	move.w	d0,StartNumber(a6)
	move.w	#1,PosterFlag(a6)
	rts

SetEndNumber::
	bsr	Asc2int
	move.w	d0,EndNumber(a6)
	move.w	#1,PosterFlag(a6)
	rts

******************************************************************
**				data aria			**
******************************************************************

		.data
		.quad

OPTION_TABLE::
	.dc.l	SetFrameNumber
	.dc.l	SetLoadPoint
	.dc.l	SetSVDFV3Mode
	.dc.l	SetViewMode
	.dc.l	SetFastDrawMode
	.dc.l	SetStartNumber
	.dc.l	SetEndNumber

OPTIONS::
	.dc.b	'f',0
	.dc.b	'a',0
	.dc.b	'3',0
	.dc.b	'v',0
	.dc.b	'd',0
	.dc.b	's',0
	.dc.b	'e',0,0

	.even

TextMask::
	.dc.w	3
	.dc.w	512
	.dc.w	0
	.dc.w	256
	.dc.w	512
	.dc.w	$ffff

TextMaskClr::
	.dc.w	3
	.dc.w	512
	.dc.w	0
	.dc.w	256
	.dc.w	512
	.dc.w	0

TextPalet::
		*3210
	.dc.w	$0000			*0000
	.dc.w	$0001			*0001	wi
	.dc.w	$ffff			*0011	wi
	.dc.w	$ffff			*0010	
	.dc.w	$0001			*0100	BOX
	.dc.w	$0001			*0101
	.dc.w	$0001			*0110
	.dc.w	$0001			*0111
	.dc.w	$0001			*1000	}XN
	.dc.w	$ffff			*1001
	.dc.w	$ffff			*1010
	.dc.w	$ffff			*1011
	.dc.w	$de6c			*1100
	.dc.w	$ffff			*1101
	.dc.w	$ffff			*1110
	.dc.w	$ffff			*1111

To384x256::
	.dc.w	$0045			* R0
	.dc.w	$0005			* R1
	.dc.w	$000a			* R2
	.dc.w	$003a			* R3
	.dc.w	$0237			* R4
	.dc.w	$0005			* R5
	.dc.w	$0028			* R6
	.dc.w	$0228			* R7
	.dc.w	$8311			* R20
	.dc.w	$0001			* set

To768x512::
	.dc.w	$0089			* R0
	.dc.w	$000e			* R1
	.dc.w	$001c			* R2
	.dc.w	$007c			* R3
	.dc.w	$0237			* R4
	.dc.w	$0005			* R5
	.dc.w	$0028			* R6
	.dc.w	$0228			* R7
	.dc.w	$0316			* R20
	.dc.w	$0000			* set

To512x512::
	.dc.w	$005b			* R0
	.dc.w	$0008			* R1
	.dc.w	$0011			* R2
	.dc.w	$0051			* R3
	.dc.w	$0237			* R4
	.dc.w	$0005			* R5
	.dc.w	$0028			* R6
	.dc.w	$0228			* R7
	.dc.w	$0315			* R20
	.dc.w	$0000			* set

To256x256::
	.dc.w	$002d			* R0
	.dc.w	$0004			* R1
	.dc.w	$0006			* R2
	.dc.w	$0026			* R3
	.dc.w	$0237			* R4
	.dc.w	$0005			* R5
	.dc.w	$0028			* R6
	.dc.w	$0228			* R7
	.dc.w	$0310			* R20
	.dc.w	$0000			* set

To512x256::
	.dc.w	$005b			* R0
	.dc.w	$0009			* R1
	.dc.w	$0011			* R2
	.dc.w	$0051			* R3
	.dc.w	$0237			* R4
	.dc.w	$0005			* R5
	.dc.w	$0028			* R6
	.dc.w	$0228			* R7
	.dc.w	$0311			* R20
	.dc.w	$0000			* set

To512x384::
	.dc.w	$0089			* R0
	.dc.w	$000a			* R1
	.dc.w	$002c			* R2
	.dc.w	$006c			* R3
	.dc.w	$020b			* R4
	.dc.w	$0007			* R5
	.dc.w	$0048			* R6
	.dc.w	$01c8			* R7
	.dc.w	$0316			* R20
	.dc.w	$0000			* set

*************************
*	Message		*
*************************

TitleMes::
	.dc.b	'.xvd Easy Frame Viewer 2 ver0.81 May 30 1999 FunaPon',CR,LF
	.dc.b	CR,LF,0
USAGE::
	.dc.b	'usage : xvdfv2 <option> xvdfile',CR,LF
	.dc.b	CR,LF
	.dc.b	'option: -f[num] : num = frame number (0n65535)',CR,LF
	.dc.b	'      : -a[x,y] : x,y = load point',CR,LF
	.dc.b	'      : -a      : One Frame Only load',CR,LF
	.dc.b	'      : -3      : SVDFV3 Mode',CR,LF
	.dc.b	'      : -v      : View Mode',CR,LF
	.dc.b	'      : -d      : Fast Draw Mode',CR,LF
	.dc.b	'      : -s[num] : num = View Start frame number (0n65535)',CR,LF
	.dc.b	'      : -e[num] : num = View End   frame number (0n65535)',CR,LF,0

NoFileMes::		.dc.b	'wt@C݂͑܂D',CR,LF,0
NoOptionMes::		.dc.b	'w肳ꂽIvV݂͑܂D',CR,LF,0
NotXvdDataMes::		.dc.b	'XVDt@Cł͂܂D',CR,LF,0
FrameNumberErrorMes::	.dc.b	'w肳ꂽt[傫܂D',CR,LF,0
ImageTypeErrorMes::	.dc.b	' Image Type ɂ͑ΉĂ܂D',CR,LF,0
NotRev2Mes::		.dc.b	'Revision 2 ł͂܂D',CR,LF,0
OverXNumberMes::	.dc.b	'w肳ꂽwW傫܂D',CR,LF,0
OverYNumberMes::	.dc.b	'w肳ꂽxW傫܂D',CR,LF,0
ViewNumberErrorMes::	.dc.b	'StartNumberEndNumberI',CR,LF,0
OpenErrorMes::		.dc.b	'w肳ꂽt@CJ܂D',CR,LF,0
ReadErrorMes::		.dc.b	'w肳ꂽt@Cǂ߂܂D',CR,LF,0
WriteErrorMes::		.dc.b	't@Cɏ߂܂D',CR,LF,0
SeekErrorMes::		.dc.b	'w肳ꂽt@CV[Nł܂D',CR,LF,0
MallocErrorMes::	.dc.b	'mۂł܂D',CR,LF,0

Keisoku::		.dc.b	'v',0
White::			.dc.b	'           ',0
Fps::			.dc.b	'fps',0

******************************************************************
**				bss aria			**
******************************************************************

	.bss
	.even

WORK::
	.ds.b	WORK_SIZE

	.stack
	.even

MYSTACK::
	.ds.l	256		*X^bN̈
MYSP::

	.end
